SystemOrganization addCategory: #'Tp3-METAPROGRAMACION'!
SystemOrganization addCategory: 'Tp3-METAPROGRAMACION-DOMINIO'!
SystemOrganization addCategory: 'Tp3-METAPROGRAMACION-TEST'!

Trait named: #GenericEquals
	uses: {}
	category: 'Tp3-METAPROGRAMACION'!

!GenericEquals methodsFor: 'as yet unclassified' stamp: 'marcos 5/6/2014 17:32'!
= unObjeto
	"Toma la lista de variables de #keyProperties determina si el objeto receptor es igual al recibido por parámetro"

	^ self class = unObjeto class and: 
		[ self keyProperties allSatisfy: 
			[:varName | (self instVarNamed: varName) = (unObjeto instVarNamed: varName)]
		]! !

!GenericEquals methodsFor: 'as yet unclassified' stamp: 'Marcos 5/6/2014 20:17'!
keyProperties
	"Espera que le entregen una lista de Strings, que representan un conjunto de nombres de variables de instancia"
	^self requirement.! !

Trait named: #GenericPrint
	uses: {}
	category: 'Tp3-METAPROGRAMACION'!

!GenericPrint methodsFor: 'as yet unclassified' stamp: 'Marcos 5/7/2014 05:45'!
keyProperties
	"Espera que le entregen una lista de Strings, que representan un conjunto de nombres de variables de instancia"
	^self requirement.! !

!GenericPrint methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 14:29'!
printOn
	"comment stating purpose of message"
	| cadena|

	cadena:= (self class) printString, ' ('.
	self keyProperties do: 	[:varName | cadena := cadena, varName, ' = ', (self instVarNamed: varName) printString, ', '].
	
	^ cadena, ')'.
	
"	aStream << self class name;
	<< #posicion;
	<< $=;
	print: self posicion.
	
	^ aStream."
	! !

Object subclass: #BarDeMoe
	instanceVariableNames: 'clientes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-DOMINIO'!

!BarDeMoe methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 14:10'!
clientesQuePuedenBeber
	"Devuelve la lista de clientes que pueden beber"

	^ clientes select: [ :unCliente | self puedeBeber: unCliente. ]
	! !

!BarDeMoe methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 13:28'!
initialize
	clientes := Bag new.! !

!BarDeMoe methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 13:30'!
nuevoCliente: unCliente
	"agrega una persona a la lista de clientes"

	clientes add: unCliente.! !

!BarDeMoe methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/14/2014 01:01'!
puedeBeber: unaPersona
	"Devuelve verdadero si unaPersona puede beber, es decir, si tiene o es mayor de 18 años"

	^ unaPersona edad  >= 18.! !

Object subclass: #Persona
	instanceVariableNames: 'nombre edad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-DOMINIO'!

Persona class
	instanceVariableNames: 'edad'!

Persona class
	instanceVariableNames: 'edad'!

!Persona class methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 17:27'!
edad 
	^ edad! !

!Persona class methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 17:27'!
edad: valor
	edad:= valor! !

!Persona class methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 13:18'!
nombre: unNombre edad: unaEdad
		^ self new initialize: unNombre  edad: unaEdad.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/14/2014 01:01'!
edad 
	^ edad! !

!Persona methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/14/2014 01:01'!
edad: valor
	edad:= valor! !

!Persona methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 13:15'!
esMayorDeEdad
	"Devuelve Verdadero solo si la persona tiene, o es mayor, de 21 años."

	^ edad >= 21.
! !

!Persona methodsFor: 'initialization' stamp: 'MarcosBenitez 5/13/2014 13:16'!
initialize: unNombre edad: unaEdad
	edad := unaEdad.
	nombre := unNombre .! !

!Persona methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 15:46'!
nombre 
	^ nombre! !

!Persona methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 15:46'!
nombre: valor
	nombre:= valor! !

Object subclass: #RenameProperty
	instanceVariableNames: 'nombre nuevoNombre clase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION'!

!RenameProperty class methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 15:28'!
changeMessages: nombre to: nuevoNombre from: metodo
	"Cambia los mensajes nombre por nuevoNombre dentro del metodo indicado"

	| code clase |

	clase:= metodo methodClass .
	code := metodo getSource.

	code := code copyReplaceAll: nombre with: nuevoNombre.

	clase compile: code.
	
	
! !

!RenameProperty class methodsFor: 'as yet unclassified' stamp: 'Marcos 5/10/2014 20:45'!
fullRenameProperty: nombre to: nuevoNombre from: clase
	"Se rrecorren todos los metodos de todas las clases de package y si en alguno se envia el mensage nombre se renombra dicho mensaje a nuevoNombre"
	
	| clases mensaje |
	
	mensaje:= nombre asSymbol.
	clases:= SystemOrganization classesInCategory:  (clase category).
	Transcript  show: mensaje, '
'.
	
	self renameProperty: nombre to: nuevoNombre  from: clase. 

	clases do: [:unaClase | unaClase methodDictionary do: 
		[: metodo|
			( metodo messages includes: mensaje) ifTrue: [(metodo messages) remove: mensaje; add: nombre asSymbol ]
		]
	].! !

!RenameProperty class methodsFor: 'as yet unclassified' stamp: 'Marcos 5/13/2014 12:24'!
renameProperty: nombre to: nuevoNombre from: objeto
	| valor |
	objeto isClass
		ifTrue: [
			 self renameProperty: nombre to: nuevoNombre  fromClass: objeto.
		];
		ifFalse: [ 
			valor := objeto instVarNamed: nombre.
			self renameProperty: nombre to: nuevoNombre  fromClass: objeto class.
			objeto instVarNamed: nuevoNombre put: valor.
		].! !

!RenameProperty class methodsFor: 'as yet unclassified' stamp: 'Marcos 5/13/2014 12:14'!
renameProperty: nombre to: nuevoNombre fromClass: clase

	clase addInstVarNamed: nuevoNombre.
	
	clase removeSelector:  nombre asSymbol;  compile: nuevoNombre , ' 
	^ ', nuevoNombre.
	
	clase removeSelector: (nombre, ':') asSymbol; compile: nuevoNombre , ': valor
	', nuevoNombre, ':= valor'.

	clase removeInstVarNamed: nombre.! !

!RenameProperty methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 23:06'!
changeMessages: metodo
	"Cambia los mensajes nombre por nuevoNombre dentro del metodo indicado"

	| code class|

	class := metodo methodClass .
	code := metodo getSource.

	code := code copyReplaceAll: nombre with: nuevoNombre.

	class compile: code.
	
	! !

!RenameProperty methodsFor: 'accessing' stamp: 'MarcosBenitez 5/13/2014 16:39'!
clase
	^ clase! !

!RenameProperty methodsFor: 'accessing' stamp: 'MarcosBenitez 5/13/2014 16:39'!
clase: anObject
	clase := anObject! !

!RenameProperty methodsFor: 'execute' stamp: 'MarcosBenitez 5/13/2014 16:40'!
execute
	"Renombra la variable de instancia del objeto y sus Getters y Setters"
	
	clase isClass
		ifTrue: [
			 self renameProperty.
		];
		ifFalse: [ 
			self renamePropertyFromObjet .
		].
! !

!RenameProperty methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 17:30'!
fullRenameProperty
	"Se rrecorren todos los metodos de todas las clases de package y si en alguno se envia el mensage nombre se renombra dicho mensaje a nuevoNombre"
	
	| clases mensaje |
	
	mensaje:= nombre asSymbol.
	clases:= SystemOrganization classesInCategory:  (clase category).
	
	self execute. 

	clases do: [:unaClase | unaClase methodDictionary do: 
		[: metodo|
			( metodo messages includes: mensaje) ifTrue: [ self changeMessages: metodo ]
		]
	].! !

!RenameProperty methodsFor: 'accessing' stamp: 'MarcosBenitez 5/13/2014 15:26'!
nombre
	^ nombre! !

!RenameProperty methodsFor: 'accessing' stamp: 'MarcosBenitez 5/13/2014 15:26'!
nombre: anObject
	nombre := anObject! !

!RenameProperty methodsFor: 'accessing' stamp: 'MarcosBenitez 5/13/2014 15:26'!
nuevoNombre
	^ nuevoNombre! !

!RenameProperty methodsFor: 'accessing' stamp: 'MarcosBenitez 5/13/2014 15:26'!
nuevoNombre: anObject
	nuevoNombre := anObject! !

!RenameProperty methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 19:00'!
renameProperty
	
	clase  addInstVarNamed:  nuevoNombre  asSymbol;
	compile: nuevoNombre , ' 
	^ ', nuevoNombre;
	removeSelector: (nombre) asSymbol.
	
	clase removeSelector: (nombre, ':') asSymbol;
	compile: nuevoNombre , ': valor
	', nuevoNombre, ':= valor'.

	clase removeInstVarNamed: nombre.! !

!RenameProperty methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 17:08'!
renamePropertyFromObjet
	| objeto valor|
	
	objeto := clase.
	clase := clase class.
	
	valor := objeto instVarNamed: nombre.
	self renameProperty.
	objeto instVarNamed: nuevoNombre put: valor.
	
	clase := objeto.! !

TestCase subclass: #FullRenamePropertyTest
	instanceVariableNames: 'rp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-TEST'!

!FullRenamePropertyTest methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 17:29'!
setUp
	"comment stating purpose of message"
	
	rp := (RenameProperty new)
		clase: Persona;
		nombre: 'edad';
		nuevoNombre: 'anios'.! !

!FullRenamePropertyTest methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 22:58'!
tearDown
	
	rp nombre: 'anios';
	nuevoNombre: 'edad'.
		
	rp fullRenameProperty.! !

!FullRenamePropertyTest methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/14/2014 00:59'!
testCase
	
	| method code | 
	
	code := 'puedeBeber: unaPersona
	"Devuelve verdadero si unaPersona puede beber, es decir, si tiene o es mayor de 18 años"

	^ unaPersona anios  >= 18.'.
	
	rp fullRenameProperty.
	
	method:= (BarDeMoe >> #puedeBeber:) getSource.
	
	self assert: method  = code.! !

TestCase subclass: #GenericEqualsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-TEST'!

!GenericEqualsTest methodsFor: 'running' stamp: 'MarcosBenitez 5/13/2014 14:46'!
setUp
	"Agrega el Trait GenericEquals a la clase Persona"
	
		Persona  addToComposition: GenericEquals.! !

!GenericEqualsTest methodsFor: 'running' stamp: 'MarcosBenitez 5/13/2014 14:47'!
tearDown
	"Elimina el metodo keyProperties  y el Trait GenericEquals a la clase Persona"
	Persona removeSelector: #keyProperties.
	Persona removeFromComposition: GenericEquals.! !

!GenericEqualsTest methodsFor: 'tests' stamp: 'MarcosBenitez 5/13/2014 14:53'!
testCase
	| a b |

	a := Persona nombre: 'Homer' edad: 38.
	b := Persona nombre: 'Barney' edad: 38.

	Persona compile: 'keyProperties
	^ #(edad)'.
	
	self assert: a = b.

	Persona compile: 'keyProperties
	^ #(edad nombre)'.
	
	self deny:  a = b.! !

TestCase subclass: #GenericPrintTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-TEST'!

!GenericPrintTest methodsFor: 'running' stamp: 'MarcosBenitez 5/13/2014 14:57'!
setUp
	"Agrega el Trait GenericEquals y el metodo keyProperties a la clase Persona."

	Persona  addToComposition: GenericPrint.
	Persona compile: 'keyProperties
	^ #(nombre edad)'.! !

!GenericPrintTest methodsFor: 'running' stamp: 'MarcosBenitez 5/13/2014 14:55'!
tearDown
	"Elimina el metodo keyProperties  y el Trait GenericEquals a la clase Persona"

	Persona removeSelector: #keyProperties.
	Persona removeFromComposition: GenericPrint .! !

!GenericPrintTest methodsFor: 'tests' stamp: 'MarcosBenitez 5/13/2014 15:04'!
testCase
	| a  |

	a := Persona nombre: 'Homer' edad: 38.
	Transcript show: a printOn. 
	self assert: ( a printOn ) = 'Persona (nombre = ''Homer'', edad = 38, )'.! !

TestCase subclass: #RenamePropertyTest
	instanceVariableNames: 'rp claseDePrueba'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-TEST'!

!RenamePropertyTest methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 17:38'!
setUp
	"comment stating purpose of message"
	
	rp := (RenameProperty new)
		clase: (Persona nombre: 'Homer' edad: 38);
		nombre: 'edad';
		nuevoNombre: 'anios'.! !

!RenamePropertyTest methodsFor: 'as yet unclassified' stamp: 'MarcosBenitez 5/13/2014 17:58'!
tearDown
	
	rp nombre: 'anios';
	nuevoNombre: 'edad'.
		
	rp execute .! !

!RenamePropertyTest methodsFor: 'tests' stamp: 'MarcosBenitez 5/13/2014 16:51'!
testCaseGetter
	
	self assert:
		(Persona canUnderstand: 'edad' asSymbol) &
		(Persona canUnderstand: 'anios' asSymbol) not.
	
	rp execute.

	self assert:
		(Persona canUnderstand: 'anios' asSymbol) &
		(Persona canUnderstand: 'edad' asSymbol) not.! !

!RenamePropertyTest methodsFor: 'tests' stamp: 'MarcosBenitez 5/13/2014 16:59'!
testCaseSetter

	self assert:
		(Persona canUnderstand: 'edad:' asSymbol) &
		(Persona canUnderstand: 'anios:' asSymbol) not.
	
	rp execute.

	self assert:
		(Persona canUnderstand: 'anios:' asSymbol) &
		(Persona canUnderstand: 'edad:' asSymbol) not.! !

!RenamePropertyTest methodsFor: 'tests' stamp: 'MarcosBenitez 5/13/2014 16:55'!
testCaseValues

	| valorPrevio|
	
	valorPrevio  := rp clase nombre.
	
	rp execute.

	self assert: valorPrevio  = 'Homer'.! !
